# Ubuntu Developer Summit web application
# Copyright (C) 2008, 2009, 2010 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from django.http import HttpResponse, HttpResponseServerError
from django.utils.html import escape

from summit.brainstorm.forms import IdeaForm

__all__ = (
    'lookup',
)


def lookup(request):
    if request.method == 'GET':
        form = IdeaForm(request.GET)
        if form.is_valid():
            idea = form.cleaned_data['idea']

            xml = u"<idea>\n"
            xml += u"  <id>%s</id>\n" % escape(idea.id)
            xml += u"  <title>%s</title>\n" % escape(idea.title)
            xml += u"  <url>%s</url>\n" % escape(idea.url)
            xml += u"</idea>\n"

            return HttpResponse(xml, mimetype='text/xml')
        else:
            xml = u"<errors>\n"
            for error in form.errors['idea']:
                xml += u"  <error>%s</error>\n" % escape(unicode(error))
            xml += u"</errors>\n"

            return HttpResponse(xml, mimetype='text/xml')
    else:
        return HttpResponseServerError('<h1>Wrong method</h1>')
